// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniHTML/View.subproj/OHHTMLDocument.h,v 1.6 1998/05/19 05:07:38 wjs Exp $

#import "OHHTMLOwner.h"

@class NSLock, NSArray, NSMutableArray;
@class OHForm, OHHTMLPageView, OHColorPalette, OHInlineImageCell, OHAppletCell;
@class OWScriptContext, OWScriptDocumentProxy;

#import "OHDocumentProtocol.h"

@interface OHHTMLDocument : OHHTMLOwner <OHDocument>
{
    OWContentInfo *contentInfo;

    NSLock *documentInfoLock;  /* protects "forms", "documentColorPalette", and "documentImages" */

    NSMutableArray *forms;

    // The document proxy.
    OWScriptDocumentProxy *scriptProxy;

    // The document's color palette. The only reason to keep this around is that it's visible from JavaScript.
    OHColorPalette *documentColorPalette;

    // A list of the images in the document, for use by scripts.
    NSMutableArray *documentImages;

    // A list of the applets in the document, for use by scripts.
    NSMutableArray *documentApplets;

    // This is a kind of odd place to put the script context (which contains the script interpreter(s)). However, the lifetime of a script context is one appearance of an HTML document. If we make rendered HTML documents non-cacheable, then this corresponds to the lifetime of an OHHTMLPageView. Sheesh.
    OWScriptContext *scriptContext;
}

- (OHHTMLPageView *)htmlPageView;

// Building the document
- (void)addForm:(OHForm *)form;

// Scripting interaction
- (OWScriptDocumentProxy *)scriptProxy;
- (OWScriptContext *)scriptContext;
- (NSArray *)forms;
    // Returns a snapshot of the forms array
- (OHColorPalette *)colorPalette;
- (void)setColorPalette:(OHColorPalette *)aPalette;
- (NSArray *)images;
- (void)addImage:(OHInlineImageCell *)anImage;
- (NSArray *)applets;
- (void)addApplet:(OHAppletCell *)anApplet;

@end
